/**************************************************************************
 *
 *	project				 : VisiScript
 *
 *	copyright            : (C) 2002 by Michael Neuroth
 *
 * ------------------------------------------------------------------------
 *
 *  $Source$
 *
 *  $Revision$
 *
 *	$Log$
 *
 ***************************************************************************/
/*********************************************************************************
 *																				 *
 * This file is part of the VisiScript package (a frontend for script languages) *
 *																				 *
 * Copyright (C) 2002 by Michael Neuroth.										 *
 *                                                                               *
 * This program is free software; you can redistribute it and/or modify			 *
 * it under the terms of the GNU General Public License as published by    		 *
 * the Free Software Foundation; either version 2 of the License, or             *
 * (at your option) any later version.                                           *
 *                                                                               *
 ********************************************************************************/
/**************************************************************************
 *
 *	project				 : VisiScript
 *
 *	copyright            : (C) 2002 by Michael Neuroth
 *
 * ------------------------------------------------------------------------
 *
 *  $Source$
 *
 *  $Revision$
 *
 *	$Log$
 *
 ***************************************************************************/
/*********************************************************************************
 *																				 *
 * This file is part of the VisiScript package (a frontend for script languages) *
 *																				 *
 * Copyright (C) 2002 by Michael Neuroth.										 *
 *                                                                               *
 * This program is free software; you can redistribute it and/or modify			 *
 * it under the terms of the GNU General Public License as published by    		 *
 * the Free Software Foundation; either version 2 of the License, or             *
 * (at your option) any later version.                                           *
 *                                                                               *
 ********************************************************************************/

#ifndef VISISCRIPT_H
#define VISISCRIPT_H

#include <qpe/filemanager.h>
#include <qpe/applnk.h>

#include <qmainwindow.h>

// Problems with save-as functionality with opie file-dialog
//#define _with_opie_filedialog

class FileSelector;
class QToolBar;
class QPEMenuBar;
class QWidgetStack;
class QVBox;
class QMultiLineEdit;
class QTextView;
class QPopupMenu;
class QAction;

class MyQMultiLineEdit;		// to invoke the method hasMarkedText()
class FileDialogS;

// ************************************************************************

class VisiScript : public QMainWindow
{
    Q_OBJECT

public:
    VisiScript( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~VisiScript();

public slots:
    void sltFileNew();
    void sltFileOpen();
    void sltFileSave();
    void sltFileSaveAs();
    void sltFileSaveOutputAs();
    void sltFileImport();
    void sltFileExport();
    void sltEditUndo();
    void sltEditRedo();
    void sltEditCut();
    void sltEditCopy();
    void sltEditPaste();
    void sltClearOutput();
    void sltClearScript();
    void sltRun();
    void sltSelectFont();
	//void sltSelectHelvetica();
	//void sltSelectFixed();
	//void sltSelectUnifont();
	//void sltSelectSmall();
	//void sltSelectMedium();
	//void sltSelectLarge();
	//void sltZoomIn();
	//void sltZoomOut();
	void sltMaximizeOutput();
	void sltMaximizeScript();
    void sltShowAbout();

private slots:
    void sltNewFile( const DocLnk & );
    void sltOpenFile( const DocLnk & );
    //void sltOpenFile( const QString & );
    void sltConfiguration();
    void sltShowScript();
    void sltFileAboutToShow();
    void sltEditAboutToShow();
    void sltViewAboutToShow();
#ifndef _with_opie_filedialog
	void sltDoImport();
    void sltDoExport();
#endif

protected:
    void closeEvent( QCloseEvent * pCloseEvent );

private:
    void updateCaption( const QString & sName=QString::null );
    void updateFileSelector();
    void loadInit();
    void saveInit();
    bool CheckData();
	void UpdateFont();

	// ** data **
#ifndef _with_opie_filedialog
	FileDialogS *		m_pExportFileDlg;
#endif

	FileSelector *		m_pFileSelector;
	QToolBar *			m_pMenu;
	QToolBar *			m_pButtonBar;
	QPEMenuBar *		m_pMenuBar;
	QWidgetStack *		m_pStack;
	QVBox * 			m_pVBox;
	MyQMultiLineEdit * 	m_pScript;
	//QTextView *			m_pScript;		// only readonly possible !
	MyQMultiLineEdit *	m_pOutput;

    QPopupMenu * 		pFile;
    QPopupMenu * 		pEdit;
	QPopupMenu * 		pView;

	//QAction *			m_pFixedAction;
	//QAction *			m_pHelveticaAction;
	//QAction *			m_pUnifontAction;
	//QAction *			m_pSmallAction;
	//QAction *			m_pMediumAction;
	//QAction *			m_pLargeAction;
	QAction *			m_pMaximizeScript;
	QAction *			m_pMaximizeOutput;
	QAction *			m_pCopyAction;
	QAction *			m_pCutAction;
	QAction *			m_pPasteAction;

    DocLnk 				m_aDoc;

	QString				m_sScriptCmd;
	QString				m_sScriptExtention;

	QString				m_sFontName;
	QString				m_sFontStyle;
	int					m_iFontSize;

	bool				m_bSaveOutput;
};

#endif // VISISCRIPT
